//  prop_color.cpp
//
//	select colorspace
//
//	Copyright (c) 2005 N099
//
#include <streams.h>     // DirectShow (includes windows.h)
#include <dvdmedia.h>

#include "hwdeintuids.h"
#include "hwdeint.h"

#include "prop_color.h"
#include "resource.h"

#define IsEnable(x,y) (((x)&(y)) == 0 ? 0 : 1)
#define IsDisable(x,y) (((x)&(y)) == 0 ? 1 : 0)
#define NegMask(x,y)  (((x)&(y)) == 0 ? (x)|(y) : (x)&(~(y)))

CUnknown * WINAPI CHWDeintProp_Color::CreateInstance(LPUNKNOWN punk, HRESULT *phr)
{
    CHWDeintProp_Color * pNewObject = new CHWDeintProp_Color(punk);
    if (pNewObject == NULL)
	{
        *phr = E_OUTOFMEMORY;
    }
    return pNewObject;
}


CHWDeintProp_Color::CHWDeintProp_Color(LPUNKNOWN pUnk) :
	CBasePropertyPage(NAME("HWDeintProp_Color"), pUnk, IDD_HWDeintProp_Color, IDS_HWDeintProp_Color)
	,m_pHWDeint(0)
{}

void CHWDeintProp_Color::SetDirty(void)
{
	m_bDirty = TRUE;
	if (m_pPageSite)
    {
		m_pPageSite->OnStatusChange(PROPPAGESTATUS_DIRTY);
    }
}

HRESULT CHWDeintProp_Color::OnConnect(IUnknown *pUnk)
{
    ASSERT(m_pHWDeint == NULL);
    HRESULT hr;
        // pUnk ŃtB^̃JX^ C^[tFCX₢킹B
    hr = pUnk->QueryInterface(IID_IHWDeint,
             reinterpret_cast<void**>(&m_pHWDeint));
    return hr;
}

HRESULT CHWDeintProp_Color::OnActivate(void)
{
    ASSERT(m_pHWDeint != NULL);
    m_pHWDeint->get_cfg_color(&m_color);

	// Load Buttons
	SendDlgItemMessage(m_Dlg, IDC_YUY2, BM_SETCHECK, IsEnable(m_color,TYPE_YUY2), 0);
	SendDlgItemMessage(m_Dlg, IDC_UYVY, BM_SETCHECK, IsEnable(m_color,TYPE_UYVY), 0);
	SendDlgItemMessage(m_Dlg, IDC_YV12, BM_SETCHECK, IsEnable(m_color,TYPE_YV12), 0);
	SendDlgItemMessage(m_Dlg, IDC_NV12, BM_SETCHECK, IsEnable(m_color,TYPE_NV12), 0);
	SendDlgItemMessage(m_Dlg, IDC_RGB24, BM_SETCHECK, IsEnable(m_color,TYPE_RGB24), 0);
	SendDlgItemMessage(m_Dlg, IDC_RGB32, BM_SETCHECK, IsEnable(m_color,TYPE_RGB32), 0);
	SendDlgItemMessage(m_Dlg, IDC_ARGB32, BM_SETCHECK, IsEnable(m_color,TYPE_ARGB32), 0);
	SendDlgItemMessage(m_Dlg, IDC_RGB565, BM_SETCHECK, IsEnable(m_color,TYPE_RGB565), 0);
	SendDlgItemMessage(m_Dlg, IDC_RGB555, BM_SETCHECK, IsEnable(m_color,TYPE_RGB555), 0);
	SendDlgItemMessage(m_Dlg, IDC_ALL, BM_SETCHECK, IsEnable(m_color,TYPE_ALL), 0);
	SendDlgItemMessage(m_Dlg, IDC_YVYU, BM_SETCHECK, IsEnable(m_color,TYPE_YVYU), 0);
	SendDlgItemMessage(m_Dlg, IDC_YUYV, BM_SETCHECK, IsEnable(m_color,TYPE_YUYV), 0);
	SendDlgItemMessage(m_Dlg, IDC_AYUV, BM_SETCHECK, IsEnable(m_color,TYPE_AYUV), 0);
	SendDlgItemMessage(m_Dlg, IDC_Y211, BM_SETCHECK, IsEnable(m_color,TYPE_Y211), 0);
	SendDlgItemMessage(m_Dlg, IDC_Y41P, BM_SETCHECK, IsEnable(m_color,TYPE_Y41P), 0);
	SendDlgItemMessage(m_Dlg, IDC_Y411, BM_SETCHECK, IsEnable(m_color,TYPE_Y411), 0);
	SendDlgItemMessage(m_Dlg, IDC_YVU9, BM_SETCHECK, IsEnable(m_color,TYPE_YVU9), 0);
	SendDlgItemMessage(m_Dlg, IDC_I420, BM_SETCHECK, IsEnable(m_color,TYPE_I420), 0);
	SendDlgItemMessage(m_Dlg, IDC_IYUV, BM_SETCHECK, IsEnable(m_color,TYPE_IYUV), 0);
	SendDlgItemMessage(m_Dlg, IDC_NV21, BM_SETCHECK, IsEnable(m_color,TYPE_NV21), 0);
	SendDlgItemMessage(m_Dlg, IDC_IMC1, BM_SETCHECK, IsEnable(m_color,TYPE_IMC1), 0);
	SendDlgItemMessage(m_Dlg, IDC_IMC2, BM_SETCHECK, IsEnable(m_color,TYPE_IMC2), 0);
	SendDlgItemMessage(m_Dlg, IDC_IMC3, BM_SETCHECK, IsEnable(m_color,TYPE_IMC3), 0);
	SendDlgItemMessage(m_Dlg, IDC_IMC4, BM_SETCHECK, IsEnable(m_color,TYPE_IMC4), 0);

	//Enable windows
	EnableWindows();

    return S_OK;
}

HRESULT CHWDeintProp_Color::EnableWindows(void)
{
	//Enable windows
	EnableWindow(GetDlgItem(m_Dlg, IDC_RGB555), IsDisable(m_color,TYPE_ALL));
	EnableWindow(GetDlgItem(m_Dlg, IDC_RGB565), IsDisable(m_color,TYPE_ALL));
	EnableWindow(GetDlgItem(m_Dlg, IDC_RGB24), IsDisable(m_color,TYPE_ALL));
	EnableWindow(GetDlgItem(m_Dlg, IDC_RGB32), IsDisable(m_color,TYPE_ALL));
	EnableWindow(GetDlgItem(m_Dlg, IDC_ARGB32), IsDisable(m_color,TYPE_ALL));
	EnableWindow(GetDlgItem(m_Dlg, IDC_YUY2), IsDisable(m_color,TYPE_ALL));
	EnableWindow(GetDlgItem(m_Dlg, IDC_UYVY), IsDisable(m_color,TYPE_ALL));
	EnableWindow(GetDlgItem(m_Dlg, IDC_YVYU), IsDisable(m_color,TYPE_ALL));
	EnableWindow(GetDlgItem(m_Dlg, IDC_YUYV), IsDisable(m_color,TYPE_ALL));
	EnableWindow(GetDlgItem(m_Dlg, IDC_AYUV), IsDisable(m_color,TYPE_ALL));
	EnableWindow(GetDlgItem(m_Dlg, IDC_Y211), IsDisable(m_color,TYPE_ALL));
	EnableWindow(GetDlgItem(m_Dlg, IDC_Y41P), IsDisable(m_color,TYPE_ALL));
	EnableWindow(GetDlgItem(m_Dlg, IDC_Y411), IsDisable(m_color,TYPE_ALL));
	EnableWindow(GetDlgItem(m_Dlg, IDC_YVU9), IsDisable(m_color,TYPE_ALL));
	EnableWindow(GetDlgItem(m_Dlg, IDC_YV12), IsDisable(m_color,TYPE_ALL));
	EnableWindow(GetDlgItem(m_Dlg, IDC_IYUV), IsDisable(m_color,TYPE_ALL));
	EnableWindow(GetDlgItem(m_Dlg, IDC_I420), IsDisable(m_color,TYPE_ALL));
	EnableWindow(GetDlgItem(m_Dlg, IDC_NV12), IsDisable(m_color,TYPE_ALL));
	EnableWindow(GetDlgItem(m_Dlg, IDC_NV21), IsDisable(m_color,TYPE_ALL));
	EnableWindow(GetDlgItem(m_Dlg, IDC_IMC1), IsDisable(m_color,TYPE_ALL));
	EnableWindow(GetDlgItem(m_Dlg, IDC_IMC2), IsDisable(m_color,TYPE_ALL));
	EnableWindow(GetDlgItem(m_Dlg, IDC_IMC3), IsDisable(m_color,TYPE_ALL));
	EnableWindow(GetDlgItem(m_Dlg, IDC_IMC4), IsDisable(m_color,TYPE_ALL));

    return S_OK;
}

BOOL CHWDeintProp_Color::OnReceiveMessage(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch ( uMsg )
	{
	case WM_COMMAND:
		if (LOWORD(wParam) == IDC_ALL){
			m_color = NegMask(m_color,TYPE_ALL);
			EnableWindows();
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_RGB555){
			m_color = NegMask(m_color,TYPE_RGB555);
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_RGB565){
			m_color = NegMask(m_color,TYPE_RGB565);
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_RGB24){
			m_color = NegMask(m_color,TYPE_RGB24);
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_RGB32){
			m_color = NegMask(m_color,TYPE_RGB32);
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_ARGB32){
			m_color = NegMask(m_color,TYPE_ARGB32);
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_YUY2){
			m_color = NegMask(m_color,TYPE_YUY2);
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_UYVY){
			m_color = NegMask(m_color,TYPE_UYVY);
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_YVYU){
			m_color = NegMask(m_color,TYPE_YVYU);
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_YUYV){
			m_color = NegMask(m_color,TYPE_YUYV);
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_AYUV){
			m_color = NegMask(m_color,TYPE_AYUV);
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_Y211){
			m_color = NegMask(m_color,TYPE_Y211);
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_Y41P){
			m_color = NegMask(m_color,TYPE_Y41P);
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_Y411){
			m_color = NegMask(m_color,TYPE_Y411);
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_YVU9){
			m_color = NegMask(m_color,TYPE_YVU9);
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_I420){
			m_color = NegMask(m_color,TYPE_I420);
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_YV12){
			m_color = NegMask(m_color,TYPE_YV12);
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_IYUV){
			m_color = NegMask(m_color,TYPE_IYUV);
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_NV12){
			m_color = NegMask(m_color,TYPE_NV12);
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_NV21){
			m_color = NegMask(m_color,TYPE_NV21);
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_IMC1){
			m_color = NegMask(m_color,TYPE_IMC1);
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_IMC2){
			m_color = NegMask(m_color,TYPE_IMC2);
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_IMC3){
			m_color = NegMask(m_color,TYPE_IMC3);
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_IMC4){
			m_color = NegMask(m_color,TYPE_IMC4);
			SetDirty();
			return (LRESULT) 1;
		}
		break;
	}
	// eNXɃbZ[WB
    return CBasePropertyPage::OnReceiveMessage(hwnd,uMsg,wParam,lParam);
}

HRESULT CHWDeintProp_Color::OnApplyChanges(void)
{
	if(!m_color){ //ЂƂIĂȂƂ͋IALLɂ
		m_color = TYPE_ALL;
		SendDlgItemMessage(m_Dlg, IDC_ALL, BM_SETCHECK, IsEnable(m_color,TYPE_ALL), 0);
		EnableWindows();
	}
	m_pHWDeint->set_cfg_color(m_color);

	return S_OK;
} 

HRESULT CHWDeintProp_Color::OnDisconnect(void)
{
    if (m_pHWDeint)
    {
        m_pHWDeint->Release();
        m_pHWDeint = NULL;
    }
    return S_OK;
}


